<?xml version="1.0" encoding="utf-8" ?>
<databaseChangeLog
    xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
    xmlns:ext="http://www.liquibase.org/xml/ns/dbchangelog-ext"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.9.xsd
                        http://www.liquibase.org/xml/ns/dbchangelog-ext http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-ext.xsd">

    <property name="autoIncrement" value="true"/>
    <changeSet id="v2.0.1" author="phong-tp">
        <createTable tableName="tag">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(100)">
                <constraints nullable="false"/>
            </column>
            <column name="active" type="boolean" defaultValue="true"/>
            <column name="block" type="boolean"/>
            <column name="search_count" type="int"/>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
    </changeSet>
    <changeSet id="v2.0.2" author="phong-tp">
        <createTable tableName="category">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(100)">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <createTable tableName="tag_category">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="category_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="tag_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <addForeignKeyConstraint baseTableName="tag_category" baseColumnNames="tag_id" constraintName="fk_tag_cate" referencedTableName="tag"
                                 referencedColumnNames="id"/>
        <addForeignKeyConstraint baseTableName="tag_category" baseColumnNames="category_id" constraintName="fk_cate_tag" referencedTableName="category"
                                 referencedColumnNames="id"/>
    </changeSet>
    <changeSet id="v2.0.3" author="phong-tp">
        <createTable tableName="employer">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
    </changeSet>
    <changeSet id="v2.0.4" author="phong-tp">
        <createTable tableName="managerial_position">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
    </changeSet>
    <changeSet id="v2.0.5" author="phong-tp">
        <createTable tableName="business_area">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
    </changeSet>
    <changeSet id="v2.0.6" author="phong-tp">
        <createTable tableName="country">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
    </changeSet>
    <changeSet id="v2.0.7" author="phong-tp">
        <createTable tableName="region">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="country_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <addForeignKeyConstraint baseTableName="region" baseColumnNames="country_id" constraintName="fk_country_region"
                                 referencedTableName="country"
                                 referencedColumnNames="id"/>
    </changeSet>
    <changeSet id="v2.0.8" author="phong-tp">
        <createTable tableName="candidate">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="first_name" type="varchar(100)">
                <constraints nullable="false"/>
            </column>
            <column name="last_name" type="varchar(100)">
                <constraints nullable="false"/>
            </column>
            <column name="birth_year" type="int">
                <constraints nullable="false"/>
            </column>
            <column name="personal_number" type="varchar(12)">
                <constraints nullable="false"/>
            </column>
            <column name="gender" type="varchar(20)">
                <constraints nullable="false"/>
            </column>
            <column name="region_id" type="bigint"/>
            <column name="country_id" type="bigint"/>
            <column name="linkedln_link" type="varchar(100)"/>
            <column name="first_employment" type="int"/>
            <column name="city" type="varchar(100)">
                <constraints nullable="false"/>
            </column>
            <column name="zip_code" type="varchar(30)"/>
            <column name="county" type="varchar(50)"/>
            <column name="street_address" type="varchar(50)"/>
            <column name= "phone_number" type="varchar(20)"/>
            <column name="second_phone_number" type="varchar(30)"/>
            <column name="email_private" type="varchar(50)"/>
            <column name="email_work" type="varchar(50)"/>
            <column name="deleted" type="boolean" defaultValue="false"/>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <createTable tableName="candidate_business_area">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="candidate_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="business_area_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <createTable tableName="candidate_employer">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="candidate_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="employer_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <createTable tableName="candidate_managerial_position">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="candidate_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="managerial_position_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
    </changeSet>
    <changeSet id="v2.0.9" author="phong-tp">
        <addColumn tableName="jhi_user">
            <column name="field_config" type="varchar(255)"/>
        </addColumn>
    </changeSet>
    <changeSet id="v2.0.10" author="phong-tp">
        <createTable tableName="filter_list">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(100)">
                <constraints nullable="false"/>
            </column>
            <column name="user_id" type="bigint"/>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <createTable tableName="candidate_filter_list">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="candidate_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="filter_list_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <addForeignKeyConstraint baseTableName="filter_list" baseColumnNames="user_id" constraintName="fk_filter_user"
                                 referencedTableName="jhi_user"
                                 referencedColumnNames="id"/>
        <addForeignKeyConstraint baseTableName="candidate_filter_list" baseColumnNames="candidate_id"
                                 constraintName="fk_filter_list_candidate"
                                 referencedTableName="candidate"
                                 referencedColumnNames="id" onDelete="CASCADE"/>
        <addForeignKeyConstraint baseTableName="candidate_filter_list" baseColumnNames="filter_list_id"
                                 constraintName="fk_candidate_filter"
                                 referencedTableName="filter_list"
                                 referencedColumnNames="id" onDelete="CASCADE"/>
    </changeSet>
    <changeSet id="v2.0.11" author="phong-tp">
        <createTable tableName="cv">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="file_name" type="varchar(255)">
                <constraints nullable="false"/>
            </column>
            <column name="file_path" type="varchar(255)">
                <constraints nullable="false" />
            </column>
            <column name="candidate_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
    </changeSet>
    <changeSet id="v2.0.12" author="phong-tp">
        <sql dbms="mysql">
            ALTER TABLE cv MODIFY COLUMN file_name varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
            ALTER TABLE cv MODIFY COLUMN file_path varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
        </sql>
    </changeSet>
    <changeSet id="v2.0.13" author="phong-tp">
        <createTable tableName="word">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(100)">
                <constraints nullable="false"/>
            </column>
            <column name="created_by" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
            <column name="created_date" type="timestamp"/>
            <column name="last_modified_by" type="varchar(50)"/>
            <column name="last_modified_date" type="timestamp"/>
        </createTable>
        <sql dbms="mysql">
            ALTER TABLE word MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
        </sql>
    </changeSet>
    <changeSet id="v2.0.14" author="phong-tp">
        <sql dbms="mysql">
            ALTER TABLE region MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
            ALTER TABLE country MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
        </sql>
    </changeSet>
    <changeSet id="v2.0.15" author="phong-tp">
        <sql dbms="mysql">
            ALTER TABLE tag MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
            ALTER TABLE category MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
            ALTER TABLE employer MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
            ALTER TABLE managerial_position MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
            ALTER TABLE business_area MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
        </sql>
    </changeSet>
    <changeSet id="v2.0.16" author="phong-tp">
        <sql dbms="mysql">
            ALTER TABLE category MODIFY COLUMN name varchar(100) CHARACTER SET utf8 COLLATE utf8_bin;
            ALTER TABLE tag MODIFY COLUMN name varchar(100) CHARACTER SET utf8 COLLATE utf8_bin;
            ALTER TABLE region MODIFY COLUMN name varchar(100) CHARACTER SET utf8 COLLATE utf8_bin;
            ALTER TABLE country MODIFY COLUMN name varchar(100) CHARACTER SET utf8 COLLATE utf8_bin;
        </sql>
    </changeSet>
    <changeSet id="v2.0.17" author="phong-tp">
        <sql dbms="mysql">
            ALTER TABLE filter_list MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE candidate MODIFY COLUMN first_name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE candidate MODIFY COLUMN last_name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE candidate MODIFY COLUMN city  varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE candidate MODIFY COLUMN zip_code varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE candidate MODIFY COLUMN county varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE candidate MODIFY COLUMN linkedln_link varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE candidate MODIFY COLUMN street_address varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE category MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE tag MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE region MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE country MODIFY COLUMN name varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
        </sql>
    </changeSet>
    <changeSet id="v2.0.18" author="phong-tp">
        <!--because not add relation for table candidate_business_area, when delete business area, candidate_business_area will not delete
        , candidate cannot get business_area because business_area id no more exist -->
        <sql>
            truncate table candidate_employer;
            truncate table candidate_managerial_position;
            truncate table candidate_business_area;
            truncate table employer;
            truncate table managerial_position;
            truncate table business_area;
        </sql>
        <addForeignKeyConstraint baseTableName="candidate_employer" baseColumnNames="candidate_id" constraintName="fk_candidate_employer" referencedTableName="candidate"
                                 referencedColumnNames="id"/>
        <addForeignKeyConstraint baseTableName="candidate_employer" baseColumnNames="employer_id" constraintName="fk_employer_candidate" referencedTableName="employer"
                                 referencedColumnNames="id"/>
        <addForeignKeyConstraint baseTableName="candidate_managerial_position" baseColumnNames="candidate_id" constraintName="fk_candidate_managerial" referencedTableName="candidate"
                                 referencedColumnNames="id"/>
        <addForeignKeyConstraint baseTableName="candidate_managerial_position" baseColumnNames="managerial_position_id" constraintName="fk_managerial_candidate" referencedTableName="managerial_position"
                                 referencedColumnNames="id"/>
        <addForeignKeyConstraint baseTableName="candidate_business_area" baseColumnNames="candidate_id" constraintName="fk_candidate_business_1" referencedTableName="candidate"
                                 referencedColumnNames="id"/>
        <addForeignKeyConstraint baseTableName="candidate_business_area" baseColumnNames="business_area_id" constraintName="fk_candidate_business_2" referencedTableName="business_area"
                                 referencedColumnNames="id"/>
    </changeSet>
    <changeSet id="v2.0.19" author="phong-tp">
        <addColumn tableName="cv">
            <column name="content" type="text" afterColumn="file_path"/>
        </addColumn>
        <sql dbms="mysql">
            ALTER TABLE cv MODIFY COLUMN content text CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
        </sql>
    </changeSet>
    <changeSet id="v2.0.20" author="phong-tp">
        <sql dbms="mysql">
            <!--Because tag name duplicate so query findByName throw exception NonUniqueResultException . I want to truncate tag and tag category -->
            SET FOREIGN_KEY_CHECKS = 0;
            TRUNCATE tag_category;
            TRUNCATE tag;
            SET FOREIGN_KEY_CHECKS = 1;
        </sql>
    </changeSet>
    <changeSet id="v2.0.21" author="phong-tp">
        <!--because admin account field_config value not correct, i want set filed_config to null -->
        <sql dbms="mysql">
            update jhi_user set field_config = null where id = 3;
        </sql>
    </changeSet>
    <changeSet id="v2.0.22" author="phong-tp">
        <sql dbms="mysql">
            ALTER TABLE candidate CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE cv CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE region CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE country CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE tag CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE category CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE word CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
        </sql>
    </changeSet>
    <changeSet id="v2.0.23" author="phong-tp">
        <!--because admin account field_config value not correct, I want set filed_config to null -->
        <sql dbms="mysql">
            update jhi_user set field_config = null where id in (18, 19, 3);
        </sql>
    </changeSet>
    <changeSet id="v2.0.24" author="phong-tp">
        <modifyDataType tableName="jhi_user" columnName="field_config" newDataType="text"/>
    </changeSet>
    <changeSet id="v2.0.25" author="phong-tp">
        <!--change datatype for birth year to varchar -->
        <modifyDataType tableName="candidate" columnName="birth_year" newDataType="varchar(4)"/>
        <!--add relationship between candidate and  country, relationship between candidate and region -->
        <addForeignKeyConstraint baseTableName="candidate" baseColumnNames="country_id" constraintName="fk_candidate_country" referencedTableName="country"
                                 referencedColumnNames="id"/>
        <addForeignKeyConstraint baseTableName="candidate" baseColumnNames="region_id" constraintName="fk_candidate_region" referencedTableName="region"
                                 referencedColumnNames="id"/>
    </changeSet>
    <changeSet id="v2.0.26" author="phong-tp">
        <sql dbms="mysql">
            ALTER TABLE managerial_position CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE employer CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
            ALTER TABLE business_area CONVERT TO CHARACTER SET utf8mb4 COLLATE utf8mb4_swedish_ci;
        </sql>
    </changeSet>
    <changeSet id="v2.0.27" author="phong-tp">
        <sql dbms="mysql">
            <!--Because tag name duplicate so query findByName can throw exception NonUniqueResultException . I need truncate to test again -->
            SET FOREIGN_KEY_CHECKS = 0;
            TRUNCATE tag_category;
            TRUNCATE tag;
            TRUNCATE word;
            SET FOREIGN_KEY_CHECKS = 1;
        </sql>
    </changeSet>
</databaseChangeLog>
